
/*]  Copyright (c) 2009-2010, Charles McGarvey  [**************************
**]  All rights reserved.
*
* vi:ts=4 sw=4 tw=75
*
* Distributable under the terms and conditions of the 2-clause BSD license;
* see the file COPYING for a complete text of the license.
*
**************************************************************************/

#ifndef _GAMESTATE_HH_
#define _GAMESTATE_HH_

/**
 * @file GameState.hh
 * The data.
 */

#include <string>
#include <vector>

#include <boost/shared_ptr.hpp>

#include <Moof/Camera.hh>
#include <Moof/Interpolator.hh>
#include <Moof/Script.hh>

#include "Character.hh"
#include "Heroine.hh"
#include "Scene.hh"


struct GameState
{
	Mf::Script					script;
	std::vector<std::string>	sceneList;

	HeroineP					heroine;
	SceneP						scene;

	Mf::Lerp					interp;

	Mf::Camera					camera;
};


#endif // _GAMESTATE_HH_

