
/*]  Copyright (c) 2009-2010, Charles McGarvey  [**************************
**]  All rights reserved.
*
* vi:ts=4 sw=4 tw=75
*
* Distributable under the terms and conditions of the 2-clause BSD license;
* see the file COPYING for a complete text of the license.
*
**************************************************************************/

#ifndef _MOOF_HASHTOOLS_HH_
#define _MOOF_HASHTOOLS_HH_

#include <string>

#include <stlplus/hash.hpp>


namespace Mf {


struct HashFunction
{
	// generic hash function
	unsigned operator()(const void* key, int len,
						unsigned seed = -1) const;

	inline unsigned operator()(const std::string& val) const
	{
		return (*this)(val.data(), val.length());
	}

	inline unsigned operator()(int val) const
	{
		return val;
	}
};


} // namespace Mf

#endif // _MOOF_HASHTOOLS_HH_

