
/*]  Copyright (c) 2009-2010, Charles McGarvey  [**************************
**]  All rights reserved.
*
* vi:ts=4 sw=4 tw=75
*
* Distributable under the terms and conditions of the 2-clause BSD license;
* see the file COPYING for a complete text of the license.
*
**************************************************************************/

#include "Frustum.hh"
#include "OpenGL.hh"
#include "Sphere.hh"


namespace Mf {


void Sphere::encloseVertices(const Vector3 vertices[], unsigned count)
{
	// TODO
}

void Sphere::draw(Scalar alpha) const
{
	GLUquadricObj* sphereObj = gluNewQuadric();
	gluQuadricDrawStyle(sphereObj, GLU_LINE);

	glPushMatrix();

	//glTranslate(point[0], point[1], point[2]);
	glTranslate(point);
	gluSphere(sphereObj, (GLdouble)radius, 16, 16);

	glPopMatrix();

	gluDeleteQuadric(sphereObj);
}

bool Sphere::isVisible(const Frustum& frustum) const
{
	return frustum.contains(*this);
}


} // namespace Mf

